unit SetupapiSub;

{$IMPORTEDDATA OFF}

interface

uses Windows, WinAdd;

const
  DIGCF_PRESENT = $00000002;
  DIGCF_DEVICEINTERFACE = $00000010;
  MAX_DEVICE_ID_LEN = 200;
  GUID_DISPLAY_DEVICE_ARRIVAL: TGUID = '{1ca05180-a699-450a-9a0c-de4fbe3ddd89}';

type
  HDEVINFO = THandle;
  SP_DEVINFO_DATA = record
    cbSize: DWORD;
    ClassGuid: TGUID;
    DevInst: DWORD;
    Reserved: ULONG_PTR;
  end;
  PSP_DEVINFO_DATA = ^SP_DEVINFO_DATA;

var
  SetupDiGetClassDevsW: function (const ClassGuid: TGUID;
      Enumerator: PCWSTR; hwndParent: HWND; Flags: DWORD): HDEVINFO; stdcall;
  SetupDiEnumDeviceInfo: function (DeviceInfoSet: HDEVINFO; MemberIndex: DWORD;
      DeviceInfoData: PSP_DEVINFO_DATA): BOOL; stdcall;
  SetupDiGetDeviceInstanceIdW: function (DeviceInfoSet: HDEVINFO;
      DeviceInfoData: PSP_DEVINFO_DATA; DeviceInstanceId: PWSTR;
      DeviceInstanceSize: DWORD; var RequiredSize: DWORD): BOOL; stdcall;
  SetupDiDestroyDeviceInfoList: function (DevceInfoSet: HDEVINFO): BOOL; stdcall;

implementation

uses NDllLoader;

var
  h: HMODULE;
begin
  h := LoadDLL('setupapi.dll');
  if h = 0 then
    Exit;
  SetupDiGetClassDevsW := GetProcAddress(h, 'SetupDiGetClassDevsW');
  SetupDiEnumDeviceInfo := GetProcAddress(h, 'SetupDiEnumDeviceInfo');
  SetupDiGetDeviceInstanceIdW := GetProcAddress(h, 'SetupDiGetDeviceInstanceIdW');
  SetupDiDestroyDeviceInfoList := GetProcAddress(h, 'SetupDiDestroyDeviceInfoList');
end.
